;****************************************
;*               SNG 1.0                *
;*      Shell avec Niveaux de Gris      *
;*             05/08/2004               *
;*         par Marc Plouhinec           *
;* site: http://www.thebestof.tk        *
;* Email: mailto://m_plouhinec@yahoo.fr *
;*                                      *
;****************************************

; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2 
; of the License, or (at your option) any later version.


#include "sng.inc"
debut = $9400
DEBUT_PROG =  debut+$1C
DEBUT_PROG_1 = $94
DEBUT_PROG_2 = $1C
.END
.ORG $8D28

; Les appels commencent  partir de l'adresse $8D4D.
; Le shell commence  l'tiquette DEBUT.

;Liste des appels:
;-----------------

 JP CP_HL_BC            ;$8D28
 JP FILL                ;$8D2B
 JP GRB_FILL            ;$8D2E
 JP GRB_COPY            ;$8D31
 JP CLEAR_TEXT_MEM      ;$8D34
 JP FILL_TEXT_MEM_SPACE ;$8D37
 JP DISP_DELAY          ;$8D3A
 JP NEW_INTERRUPT       ;$8D3D
 JP STOP_INTERRUPT      ;$8D40
 JP MUL_HL_BC           ;$8D43
 JP EXT_INSTR           ;$8D46
 JP INIT_LIBRARY        ;$8D49
 JP STOP_LIBRARY        ;$8D4C
 JP CP_STRING           ;$8D4F

;Routines partages (1):
;-----------------------

CP_HL_BC:
 PUSH HL
 OR A
 SBC HL,BC
 POP HL
 RET

GRB_FILL: ; Remplit GRAPH_MEM avec A
 ld hl,GRAPH_MEM
 ld bc,768
FILL: ; Remplit BC octets avec A, dbute  HL
 ld d,h
 ld e,l
 ld (hl),a
 inc de
 dec bc
 ldir
 ret

DISP_DELAY:
 EX (SP),HL
 EX (SP),HL
 RET

CALL_HL:
 LD (AdresseAAppeller),HL
 JP $0000
AdresseAAppeller = $-2


.ORG $8D74
ROM_CALLS = $+1
 jp $0000               ;$8D74 cette routine  la mme place que celle de Crash, cela permet  VTI de reconnaitre l'appel


;Buffers importants:
;-------------------

;buffer contenant le nom et l'adresse des librairies:
LIB_BUFFER:
 .DB 0,0,0,0,0,0,0,0,0,0
 .DB 0,0,0,0,0,0,0,0,0,0
 .DB 0,0,0,0,0,0,0,0,0,0
 .DB 0,0,0,0,0,0,0,0,0,0
 .DB 0,0,0,0,0,0,0,0,0,0
 .DB 0,0,0,0,0,0,0,0,0,0
 .DB 0,0,0,0,0,0,0,0,0,0
 .DB 0,0,0,0,0,0,0,0,0,0

;Cette variable contient le nombre de librairies initialises
NB_LIB .DB 0


;Routines partages (2):
;-----------------------

GRB_COPY:
 push hl
 ld hl,GRAPH_MEM
 push af
 ld a,128
 out ($10),a
 push bc
 push de
 rlca
 or a
 ret z
 dec hl
 ld c,32
 out ($10),a
 inc (hl)
 dec (hl)
 inc hl
 dec hl
 ld de,11
 ld a,c
GRB_COPY1:
 out ($10),a
 inc c
 ld b,64
GRB_COPY2:
 ld a,(hl)
 inc a
 inc hl
 ld a,(hl)
 add hl,de
 out ($11),a
 djnz GRB_COPY2
 dec h
 dec h
 dec h
 inc hl
 ld a,c
 cp 44
 jr nz,GRB_COPY1
 pop de
 pop bc
 pop af
 pop hl
 ret

CLEAR_TEXT_MEM:
 PUSH AF
 PUSH HL
 PUSH DE
 PUSH BC
 LD A,0
remplit_de_a = $-1
 ld hl,TEXT_MEM
 ld bc,128
 CALL FILL
 POP HL
 POP DE
 POP BC
 POP AF
 RET

FILL_TEXT_MEM_SPACE:
 LD A,$20
 LD (remplit_de_a),A
 CALL CLEAR_TEXT_MEM
 XOR A
 LD (remplit_de_a),A
 RET

TABLE8 = $84
TABLE = TABLE8*$100
CODE8 = TABLE8-2
CODE = TABLE-$17E

NEW_INTERRUPT: ;DE=adresse de l'interuption
 DI
 PUSH AF
 PUSH BC
 PUSH HL
 PUSH DE
 LD A,(APD_BUF) ; APD_BUF = nombre d'interruptions
 INC A
 LD (APD_BUF),A
 CP 1
 JR NZ,rajoute_int
 ld hl,TABLE
 ld de,TABLE+1
 ld (hl),CODE8
 ld bc,$0100
 ldir
 LD HL,instal_interruptions
 ld de,CODE
 LD BC,instal_interruptions_fin - instal_interruptions
 LDIR
 EX DE,HL
 JR ajoute_code

rajoute_int:
 DEC A
 LD H,0
 LD L,A
 LD BC,3
 CALL MUL_HL_BC
 LD BC,CODE+$1A
 ADD HL,BC
ajoute_code:
 POP DE
 PUSH DE
 ld (hl),$CD ;=call
 inc hl
 ld (hl),E
 inc hl
 ld (hl),D
 inc hl
 EX DE,HL
 LD HL,instal_interruptions2
 LD BC,instal_interruptions_fin2 - instal_interruptions2
 LDIR
 ld a,TABLE8
 ld i,a
 im 2
 POP DE
 POP HL
 POP BC
 POP AF
 EI
 ret

STOP_INTERRUPT: ;A=numero de l'instruction
 DI
 LD H,0
 LD L,A
 LD A,(APD_BUF)
 DEC A
 LD (APD_BUF),A
 OR A
 JR Z,arrete_interrupt
 LD BC,3
 CALL MUL_HL_BC
 LD BC,CODE+$1A
 ADD HL,BC
 LD D,H
 LD E,L
 INC HL
 INC HL
 DEC DE
ecrase_appel:
 INC HL
 INC DE
 LD A,(HL)
 LD (DE),A
 CP $4D
 JR Z,teste_arret_ecrase_appel
 LD C,B
 LD B,A
 JR ecrase_appel
teste_arret_ecrase_appel:
 PUSH HL
 LD HL,$EDFB
 CALL CP_HL_BC
 POP HL
 JR NZ,ecrase_appel
 EI
 ret
arrete_interrupt:
 im 1
 EI
 ret

MUL_HL_BC: ;HL=HL*BC
 PUSH DE
 LD D,H
 LD E,L
 LD HL,0
boucle_mul:
 XOR A
 CP B
 JR NZ,boucle_mul2
 CP C
 JR NZ,boucle_mul2
 POP DE
 RET
boucle_mul2:
 DEC BC
 ADD HL,DE
 JR boucle_mul



EXT_INSTR:
;HL=adresse des instructions  dplacer
;DE=adresse du buffer o sera execut les instructions
;BC=taille des instructions

;La mthode est simple: On copie simplement le code dans le buffer, on replace le programme avec la procdure normale,
;on lance le programme situ dans le buffer avec un call et enfin on relance la routine qui dplace le programme.

 LD (AdresseBuffer),DE
 LDIR
 RET

;Les librairies sont des programmes non-executables composs d'un regroupement de routines
;Ces routines sont lancs par des programmes ASM en cours d'execution
;c'est pourquoi les librairies ne sont pas dplaces
;Il faut donc modifier toutes les adresses fixes  l'aide d'une table place au dbut de la librairie
;Enfin pour pouvoir s'y retrouver SNG contient un buffer contenant les noms et les adresses des librairies
;Ce buffer doit contenir 8 librairies donc il fait 8*(8+2)=80 octets

INIT_LIBRARY:
;entre:
;DE->pointe vers le nom (chaine termine par un zero) de la librairie (8 lettres au max)
;sortie;
;A=1 librairie initialise correctement
;A=0 echec de l'initialisation de la librairie

 LD HL,0
;On teste s'il reste de la place pour initialiser une librairie
 LD A,(NB_LIB)
 CP 8
 JR NZ,IlResteDeLaPlace
 XOR A
 RET
IlResteDeLaPlace:

;On charge le nom dans le buffer LIB_BUFFER et dans OP1
 LD A,(NB_LIB)
 LD C,A
 LD B,0
 LD HL,10
 CALL MUL_HL_BC
 LD BC,LIB_BUFFER
 ADD HL,BC
;ici HL=adresse de l'emplacement libre pour la librairie
;    DE=adresse du nom de la librairie
 PUSH HL
ChargeNom:
 LD A,(DE)
 OR A
 JR Z,NomCharge
 LD (HL),A
 INC DE
 INC HL
 JR ChargeNom
NomCharge:
 LD (HL),A
 POP HL
 LD (AdresseLibBuffer),HL
;On cherche maintenant l'adresse de la librairie
 CALL ChercheProgVAT
 OR A
 RET Z;on renvoie une erreur si on a pas trouv la lib
;ici HL=adresse de la lib
;on incrmente NB_LIB
 PUSH HL
 LD HL,NB_LIB
 INC (HL)
 POP HL
;On adapte maintenant les adresses de la librairie
 LD A,1
 LD (AddOuSbc),A
 CALL AdapteAdressesLIB
;ici DE = adresse de la premire instruction de la lib
 LD HL,(AdresseLibBuffer)
 LD BC,8
 ADD HL,BC
 LD (HL),E
 INC HL
 LD (HL),D
;On a finit d'adapter les adresses de la librairie
 LD A,1
 RET

STOP_LIBRARY:
;entre: A=Numro de la lib  dsinitialiser
 LD HL,10
 LD B,0
 LD C,A
 CALL MUL_HL_BC
 LD BC,LIB_BUFFER
 ADD HL,BC
;ici HL=zone du buffer  enlever

 PUSH HL
;On remet les adresses de la lib comme avant
 LD BC,8
 ADD HL,BC
 CALL LD_HL_MHL
;ici HL=adresse de la lib  sa premire instruction
 CALL ChercheAdresseLibDebut
 XOR A
 LD (AddOuSbc),A
 CALL AdapteAdressesLIB
;On retire la zone occupe de la lib dans LIB_BUFFER
 LD HL,NB_LIB
 DEC (HL)
 POP HL
 LD D,H
 LD E,L
 LD BC,10
 ADD HL,BC
;ici HL=adresse de la lib juste aprs
;    DE=adresse de la lib  enlever
;On veut savoir la taille du bloc  dplacer

 PUSH DE
 EX DE,HL
 LD HL,LIB_BUFFER+80
 SBC HL,DE
 LD B,H
 LD C,L
 EX DE,HL
 POP DE
;ici BC=taille du bloc  dplacer
 LDIR
 RET


ChercheProgVAT:
;entre: HL = adresse du nom de la lib
;sortie: A=1 si a a march et A=0 s'il y a un problme
;        HL=adresse de la librairie
;la mthode est simple: on cherche la premire lettre ds la VAT puis on vrifie la suite du nom

;On calcule la taille de la VAT
 PUSH HL
 LD HL,VAT_START
 LD DE,(VAT_END)
 SBC HL,DE
 LD B,H
 LD C,L
 POP HL
;ici BC = taille de la VAT
 LD (TailleVAT),BC
 EX DE,HL
 LD HL,(VAT_END)
CherchePremiereLettre:
 LD BC,(TailleVAT)
 LD A,(DE)
 CPIR ;On cherche la premire lettre du programme dans la VAT
 LD A,B
 OR A
 JR NZ,OnATrouveUneLettre
 LD A,C
 OR A
 JR NZ,OnATrouveUneLettre
;ici BC=0, c'est  dire qu'on a pas trouv la librairie, on renvoie une erreur
 XOR A
 RET
OnATrouveUneLettre:
 LD (TailleVAT),BC
;On teste la suite de la chaine de caractre
 DEC HL
;ici HL->nom ds la VAT
;    DE->nom dans LIB_BUFFER
 LD C,1
 CALL CP_STRING
 INC HL
 OR A                       ;
 JR Z,CherchePremiereLettre ;si les chaines sont diffrentes, on continue la recherche
;sinon on verifie si c'est bien une librairie
;As-t'on test le bon nombre de lettres?
 LD A,B
 LD B,(HL)
 CP B
 JR Z,ContinueDeTester
 JR CherchePremiereLettre
ContinueDeTester:
 DEC HL
 PUSH HL
 INC HL\ INC HL\ INC HL\ INC HL
 LD A,(HL)
 POP HL
 CP 6
 JR NZ,CherchePremiereLettre
;ici on a bien un programme, on verifie maintenant que c'est bien une librairie
 PUSH HL
 PUSH DE
 INC HL\ INC HL
 LD D,(HL)
 INC HL
 LD E,(HL)
 EX DE,HL
;ici HL=adresse de la lib
 INC HL\ INC HL ;On passe les info sur la taille de la lib
 INC HL\ INC HL ;On passe stop:
 LD A,(HL)
 CP 'L'
 JR NZ,CeNestPasLaBonneLib
 INC HL
 LD A,(HL)
 CP 'I'
 JR NZ,CeNestPasLaBonneLib
 INC HL
 LD A,(HL)
 CP 'B'
 JR NZ,CeNestPasLaBonneLib
 POP DE
 POP DE
;C'est bon, c'est bien la lib cherche!
 LD BC,6
 SBC HL,BC
 LD A,1
 RET

CeNestPasLaBonneLib:
 POP DE
 POP HL
 JR CherchePremiereLettre


AdapteAdressesLIB:
;HL = adresse de la lib
;La table des adresses se situe juste aprs le mot contenant la taille de la lib
;elle est une suite de mots de 16 bits termins par l'octet 0
 LD DE,7
 ADD HL,DE
;ici HL = adresse de la table

;On cherche l'adresse de la 1re instruction de la lib
 PUSH HL
CalcTailleTab:
 XOR A
 CP (HL)
 JR Z,CalcTailleTab2
 INC HL
CalcTailleTabCont:
 INC HL
 JR CalcTailleTab
CalcTailleTab2:
 INC HL
 CP (HL)
 JR NZ,CalcTailleTabCont
 EX DE,HL
 INC DE
 POP HL
;ici DE=adresse de la 1re instruction de la lib
;    HL=adresse de la table

;On modifie les adresses
ModifieAdresse:
;On teste si on est  la fin de la table
 XOR A
 CP (HL)
 JR NZ,pTesteFinTab
 INC HL
 CP (HL)
 RET Z
 DEC HL
pTesteFinTab:
 PUSH HL
 CALL LD_HL_MHL
 ADD HL,DE
 PUSH HL
 CALL LD_HL_MHL
 LD A,0
AddOuSbc = $-1
 OR A
 JR Z,Sbc
 ADD HL,DE
 JR FinAddOuSbc
Sbc:
 SBC HL,DE
FinAddOuSbc:
 LD B,H
 LD C,L
 POP HL
 LD (HL),C
 INC HL
 LD (HL),B
 POP HL
 INC HL\ INC HL
 JR ModifieAdresse

ChercheAdresseLibDebut:
;entre: HL=adresse de la lib  sa premire instruction
;sortie: HL=adresse du programme
 LD BC,$FFFF
ChercheAdresseLibDebut_1:
 LD A,'B'
 CPDR
 LD A,(HL)
 CP 'I'
 JR NZ,ChercheAdresseLibDebut_1
 DEC HL
 LD A,(HL)
 CP 'L'
 JR NZ,ChercheAdresseLibDebut_1
 DEC HL
 DEC HL
 DEC HL
 DEC HL
 RET


CP_STRING:
;Compare 2 chaines
;entre:
;HL->chaine 1
;DE->chaine 2
;C=0 la chaine pointe par HL est crite  l'endroit
;C=1 la chaine pointe par HL est crite  l'envers
;sortie:
;A=1 - mmes chaines
;A=0 - chaines diffrentes
;B=Nombre de lettres testes
;la routine renvoie 1 seulement si un caractre test est 0

 XOR A
 LD (CP_STRING_compteur),A

 PUSH HL
 PUSH DE

CP_STRING_teste_lettre:
 LD A,0
CP_STRING_compteur = $-1
 INC A
 LD (CP_STRING_compteur),A
 LD A,(DE)
 OR A
 JR Z,CP_STRING_memes_chaines
 LD B,A
 LD A,(HL)
 OR A
 JR Z,CP_STRING_memes_chaines
 CP B
 JR NZ,CP_STRING_lettres_differentes
 LD A,C
 OR A
 JR Z,ChaineHLEndroit
 DEC HL
 JR ContinueCompChaine
ChaineHLEndroit:
 INC HL
ContinueCompChaine:
 INC DE
 JR CP_STRING_teste_lettre

CP_STRING_memes_chaines:
 LD A,1
 JR CP_STRING_quit
CP_STRING_lettres_differentes:
 XOR A
CP_STRING_quit:
 LD HL,CP_STRING_compteur
 LD B,(HL)
 DEC B
 POP DE
 POP HL
 RET





;Routines propres  SNG:
;-----------------------


AdapteROMCALL:
 LD A,($29D0)  ;pour rom |16.0:36| |17.0:37| |18.0:38| |19.0:6D| |19.006:18|
 CP $6D
 JR Z,anc_rom2
 CP $18
 JR Z,nouv_rom
;anc_rom:
 XOR A
 JR anc_rom0
anc_rom2:
 LD A,$1A
anc_rom0:
 LD (ROM_CALLar0),A
 LD HL,ROM_CALL_anciennes_rom
 JR adapte_rom_cont
nouv_rom:
 LD HL,ROM_CALL_nouvelles_rom
adapte_rom_cont:
 LD (ROM_CALLS),HL
 RET

ROM_CALL_anciennes_rom:
 LD (ROM_CALL_anciennes_romA),A
 LD (ROM_CALL_anciennes_romBC),BC
 LD (ROM_CALL_anciennes_romDE),DE
 LD (ROM_CALL_anciennes_romHL),HL
 EX (SP),HL
 LD E,(HL)
 INC HL
 LD D,(HL)
 INC HL
 EX (SP),HL
 EX DE,HL
;HL = Adresse  appeler
 LD BC,$50B
 CALL CP_HL_BC
 JR C,modif_rien
 LD DE,0
ROM_CALLar0 = $-2
 ADD HL,DE
modif_rien:
 PUSH HL
 LD A,0
ROM_CALL_anciennes_romA  = $-1
 LD BC,0
ROM_CALL_anciennes_romBC = $-2
 LD DE,0
ROM_CALL_anciennes_romDE = $-2
 LD HL,0
ROM_CALL_anciennes_romHL = $-2
 RET

ROM_CALL_nouvelles_rom: ;ROM_CALL(adresse) = CALL $8D74 \ .DW adresse
 LD (ROM_CALLan1),A  ;On sauve A
 LD (ROM_CALLan3),DE ;On sauve DE
 LD (ROM_CALLan4),BC ;On sauve BC
 LD (ROM_CALLan5),HL ;On sauve HL
 EX (SP),HL ;
 LD E,(HL)  ;
 INC HL     ; Met dans DE l'adresse  appeller
 LD D,(HL)  ;
 INC HL     ;
 EX (SP),HL ;
 LD A,$FF
 LD HL,rom_call_zones-1
 JR modif_appel
modif_appel0:
 EX DE,HL
modif_appel:
 INC A
 INC HL
 LD C,(HL)
 INC HL
 LD B,(HL)
 EX DE,HL
 CALL CP_HL_BC
 JR NC,modif_appel0
 EX DE,HL
 SLA A
 LD H,0
 LD L,A
 LD BC,rom_call_diff
 ADD HL,BC
 LD A,(HL)
 INC HL
 LD H,(HL)
 LD L,A
 ADD HL,DE
 PUSH HL
 LD BC,0
ROM_CALLan4 = $-2
 LD DE,0
ROM_CALLan3 = $-2
 LD A,0
ROM_CALLan1 = $-1
 LD HL,0
ROM_CALLan5 = $-2
 RET


ContreLEcranQuiSautille:
 ld a,$16
 out ($04),a
 ld a,$05
 out ($10),a
 RET


attend_aucune_touche:
 ROM_CALL(GET_KEY)
 EI
 halt
 or a
 jr nz,attend_aucune_touche
 ret

LanceLeProgramme:
 ROM_CALL(DEL_TMP) ;On place cette fonction ici car elle influe sur l'adresse du programme
 CALL ChargeAdresseProgDansHL
 CALL PlaceLeProg
 CALL DerniersPreparatifs
 CALL $0000
Appel_prog = $-2
 CALL RePlaceLeProg

 LD A,(AdresseBuffer+1)
 OR A
 RET Z
 CALL $0000
AdresseBuffer = $-2
 LD HL,0
 LD (AdresseBuffer),HL
 JR LanceLeProgramme


ChargeAdresseProgDansHL:
 LD HL,$FE6E
cherche_nom_ds_vat:
 LD A,($806A) ;C'est l'adresse qui contient le nom du programme qui viens d'tre execut
 LD BC,$FFFF
 CPDR
 INC HL
 LD DE,$806A
;on calcule la taille du nom du programme  lancer
 PUSH DE
 LD B,$ff
calc_taille:
 inc b
 LD A,(DE)
 inc de
 OR A
 jr nz,calc_taille
 POP DE
;B=taille du nom du programme
;on vrifie que le programme a bien le mme nombre de caractres
 INC HL
 LD A,(HL)
 DEC HL
 DEC HL
 CP B
 JR NZ,cherche_nom_ds_vat
 INC HL
continue_verif:
 INC DE
 DEC HL
 LD A,(DE)
 OR A
 JR Z,meme_chaine_de_car
 CP (HL)
 JR NZ,cherche_nom_ds_vat
 JR continue_verif
meme_chaine_de_car: ;on vrifie si c'est bien un programme ASM pour SNG
;ici HL=adresse de l'octet juste aprs le nom du prog crit  l'envers ds la vat
;et DE=adresse de l'octet juste aprs le nom du prog crit  l'endroit
 PUSH HL
 LD A,E
 SUB $6A
;ici A=nombre de lettres du programme
 INC A
 INC A
 LD B,0
 LD C,A
 ADD HL,BC
;HL=adresse de l'adresse du programme
 LD (AdresseProgVAT),HL
 LD D,(HL)
 INC HL
 LD E,(HL)
 EX DE,HL
;HL=adresse du programme
 INC HL
 INC HL
 LD A,(HL)
 CP $3B
 JR NZ,pas_un_prog_asm
 INC HL
 LD A,(HL)
 CP $31
 JR NZ,pas_un_prog_asm
 INC HL
 LD A,(HL)
 CP $33
 JR NZ,pas_un_prog_asm
 JR ChargeAdresseDansHL

pas_un_prog_asm:
 POP HL
 JR cherche_nom_ds_vat

ChargeAdresseDansHL:
 POP BC
 DEC HL\ DEC HL\ DEC HL\ DEC HL
;ici HL=adresse du programme
 RET





DeplaceProg:
;HL = adresse de depart du programme
;DE = adresse d'arrivee du programme

;Initialisation
 LD (AdresseArrProg),DE
;on dertermine la taille du programme
 LD C,(HL)
 INC HL
 LD B,(HL)
 DEC HL
 INC BC
 INC BC
 LD (TailleProg),BC
 LD (TailleDonnesRestantesADeplacer),BC
;On doit determiner si l'adresse de dpart est > ou <  l'adresse d'arrive
 CALL CP_HL_DE
 JR NC,AdresseDepPlusGrande
 LD BC,(TailleProg)
 ADD HL,BC
 CALL ChargeDsBCTailleDonneesADep2
 SBC HL,BC
 EX DE,HL
 LD BC,(TailleProg)
 ADD HL,BC
 CALL ChargeDsBCTailleDonneesADep2
 SBC HL,BC
 EX DE,HL
 XOR A
 JR CasDepartage
AdresseDepPlusGrande:
 LD A,1
CasDepartage:
 LD (AdresseDepPlusGrandeVar),A
 LD (AdresseAcopier),HL
 LD (AdresseACreer),DE

Deplace:
;On calcule la taille des donnes  dplacer, 768 s'il y a + de 768 octets restants  dplacer
 CALL ChargeDsBCTailleDonneesADep
 LD (TailleDonnesADeplacer),BC

;On copie dans GRAPH_MEM le debut du programme
 LD HL,(AdresseAcopier)
 LD DE,GRAPH_MEM
 LDIR

;On detruit (TailleDonnesADeplacer) octets du programme
 LD HL,(AdresseAcopier)
 LD DE,(TailleDonnesADeplacer)
 ROM_CALL(DEL_MEM)    ;Deletes a region of allocated memory: HL = address DE = size

;On creer (TailleDonnesADeplacer) octets  l'adresse d'arrivee du programme
 LD DE,(AdresseACreer)
 LD HL,(TailleDonnesADeplacer)
 ROM_CALL(INSERT_MEM) ;Allocates a region of memory: HL = size DE = address

;On copie dans la zone qu'on vient de crer les donnes stockes dans GRAPH_MEM
 LD DE,(AdresseACreer)
 LD HL,GRAPH_MEM
 LD BC,(TailleDonnesADeplacer)
 LDIR

;On met  jour les variables
 LD A,(AdresseDepPlusGrandeVar)
 OR A
 JR NZ,AdresseDepaPlusGrande
 CALL ChargeDsBCTailleDonneesADep2
 LD HL,(AdresseAcopier)
 SBC HL,BC
 LD (AdresseAcopier),HL
 LD HL,(AdresseACreer)
 SBC HL,BC
 LD (AdresseACreer),HL
 JR TesteFin
AdresseDepaPlusGrande:
 LD BC,(TailleDonnesADeplacer)
 LD HL,(AdresseAcopier)
 ADD HL,BC
 LD (AdresseAcopier),HL
 LD HL,(AdresseACreer)
 ADD HL,BC
 LD (AdresseACreer),HL

;On vrifie s'il reste des donnes  ecraser
TesteFin:
 LD BC,(TailleDonnesRestantesADeplacer)
 XOR A
 CP B
 JR NZ,Deplace
 CP C
 JR NZ,Deplace

;c'est bon on a termin, on doit juste modifier l'adresse du programme dans la VAT
 LD HL,(AdresseProgVAT)
 LD A,(AdresseArrProg+1)
 LD (HL),A
 INC HL
 LD A,(AdresseArrProg)
 LD (HL),A

;Fini!
 RET

ChargeDsBCTailleDonneesADep:
 PUSH HL
 PUSH DE
 LD HL,(TailleDonnesRestantesADeplacer)
 LD DE,768
 SBC HL,DE
 JP P,TaillePositive
 LD BC,(TailleDonnesRestantesADeplacer)
 JR TailleCalculee
TaillePositive:
 LD BC,768
TailleCalculee:
 SUB A    ;sert  mettre  0 le carry flag, car a influe sur sbc
 LD HL,(TailleDonnesRestantesADeplacer)
 SBC HL,BC
 LD (TailleDonnesRestantesADeplacer),HL
 POP DE
 POP HL
 RET

ChargeDsBCTailleDonneesADep2:
 PUSH HL
 LD HL,(TailleDonnesRestantesADeplacer)
 CALL ChargeDsBCTailleDonneesADep
 LD (TailleDonnesRestantesADeplacer),HL
 POP HL
 RET


PlaceLeProg:
 LD (AdresseInitProg),HL
 LD DE,DEBUT_PROG
 CALL DeplaceProg
 ROM_CALL(CREATE_TMP)
 RET

RePlaceLeProg:
 SET 1,(IY+$0D)
 RES 3,(IY+$05)
 ROM_CALL(DEL_TMP)
 LD HL,DEBUT_PROG
 LD DE,(AdresseInitProg)
 CALL DeplaceProg
 ROM_CALL(CREATE_TMP)
 RET


DerniersPreparatifs:
;On cherche l'adresse de dmarrage du programme (on saute le commentaire)
 LD HL,DEBUT_PROG+40
 XOR A
 LD BC,100
 CPIR
;maintenant, HL pointe vers l'adresse  executer
;on fait les derniers prparatifs
 PUSH HL
 XOR A                    ;Vide GRAPH_MEM
 call GRB_FILL            ;
 CALL CLEAR_TEXT_MEM
 RES 7,(IY+$14)
 RES 1,(IY+$0D)
 POP HL
;HL = Zone o est execut le prog
 LD (Appel_prog),HL
 LD HL,OP1
 LD BC,$37
 XOR A
 CALL FILL
 LD HL,APD_BUF
 LD BC,$300
 XOR A
 CALL FILL
 ROM_CALL(CLEARLCD)
 XOR A
 LD BC,0
 LD HL,0
 LD DE,0
 RET


;Variables:
;----------
TailleProg .DW 0
AdresseInitProg .DW 0
AdresseProgVAT .DW 0
AdresseAcopier .DW 0
AdresseACreer .DW 0
AdresseArrProg .DW 0
TailleDonnesADeplacer .DW 0
TailleVAT .DW 0
AdresseLibBuffer .DW 0
TailleDonnesRestantesADeplacer .DW 0
AdresseDepPlusGrandeVar .DB 0


;Constantes:
;-----------

;indispensable pour adapter les appels  la rom 19.006
rom_call_diff:
 .DW 0
 .DW 0
 .DW $1F
 .DW $51
 .DW $52
 .DW $53
 .DW $9B
 .DW $46
 .DW $57
 .DW $221
 .DW $53
 .DW $FFCE ;-32
 .DW $43
 .DW $47
 .DW $12B
 .DW $12C
 .DW $12E
 .DW $12F
 .DW $13F
 .DW $142
 .DW $145
 .DW $143
 .DW $144
 .DW $160
 .DW $166
 .DW $13C
 .DW $15D
 .DW $157
 .DW $14B
 .DW $145
 .DW $13F
 .DW $139
 .DW $1E7
 .DW $133
 .DW $13F
 .DW $127
 .DW $133
 .DW $157
 .DW $163
 .DW $163

rom_call_zones:
 .DW $0008
 .DW $0103
 .DW $021d
 .DW $0272
 .DW $027E
 .DW $059D
 .DW $05AD
 .DW $05F2
 .DW $061E
 .DW $0625
 .DW $066A
 .DW $067A
 .DW $0684
 .DW $07F8
 .DW $0A0D
 .DW $0FCE
 .DW $0FD0
 .DW $0FD5
 .DW $0FF9
 .DW $1005
 .DW $29D6
 .DW $2E1C
 .DW $2E22
 .DW $2E37
 .DW $2E3C
 .DW $2E46
 .DW $31E1
 .DW $3249
 .DW $32DF
 .DW $37B3
 .DW $37C5
 .DW $3876
 .DW $387C
 .DW $38BB
 .DW $38C7
 .DW $38D0
 .DW $390F
 .DW $3924
 .DW $4000

apropos_ch
.DB "    SNG v1.0    "
.DB " Marc Plouhinec "
.DB "www.thebestof.tk",0

instal_interruptions:
 ex      af,af'
 exx
 in      a,(3) ; check vbl int
 and     %00000010
 jr      nz,exec_interrupt
 in      a,(3) ; check on interrupt status
 rra
 ld      a,0
 adc     a,9
 out     (3),a
 ld      a,$0B
 out     (3),a
 exx
 ex      af,af'
 JP $0038
; ei
; reti
exec_interrupt:

instal_interruptions_fin:

instal_interruptions2:
 in      a,(3) ; check vbl int
 ld      a,0
 adc     a,9
 out     (3),a
 ld      a,$0B
 out     (3),a
 exx
 ex      af,af'
 ei
 reti
; JP $0038
instal_interruptions_fin2:

;Routines de dmarrage:
;----------------------

Initialistation:
 CALL AdapteROMCALL
 ROM_CALL(BUSY_OFF)           ;enlve l'indicateur en haut  droite de l'cran.
 call ContreLEcranQuiSautille
 LD A,4                       ;
 LD ($8530),A                 ;Bloque l'APD
 LD HL,0
 LD (AdresseBuffer),HL
 RET

Finalisation:
 im 1
 XOR A                    ;Vide GRAPH_MEM
 call GRB_FILL            ;
 ROM_CALL(CLEARLCD)
 call FILL_TEXT_MEM_SPACE
 LD HL,0                  ;
 LD (CURSOR_POS),HL       ;Affiche les crdits
 LD HL,apropos_ch         ;
 ROM_CALL(D_ZT_STR)       ;
 LD HL,$0007
 LD (CURSOR_POS),HL
 CALL attend_aucune_touche
 RET


 .ORG debut
;DEBUT: ;--------------------------------------------------------------------------------------------------------------------
 LD (restaure_sp+1),sp
 LD HL,$411b                  ;Pour cracker la TI-82, une zone de la RAM a t modifie,
 LD ($8114),HL                ;elle est restaure ici.
 CALL Initialistation
 CALL LanceLeProgramme
 CALL Finalisation
 ROM_CALL(BUSY_ON)        ;remet l'indicateur en haut  droite de l'cran.
restaure_sp:
 ld sp,$0000
 RET




.END